﻿using System.Runtime;

internal class Program
{
    static List<byte[]> s_buf = new List<byte[]>();

    static void Main(string[] args)
    {
        Console.WriteLine($"64bit: {Environment.Is64BitProcess}");
        Console.WriteLine($"Server GC: {GCSettings.IsServerGC}");
        // Console.WriteLine(GCSettings.LatencyMode);

        // Console.WriteLine(GC.GetGeneration(s_buf[0])); // 2

        // Workstation + x64: 243MB 한계
        // bool result = GC.TryStartNoGCRegion(243L * 1024 * 1024);

        // Workstation + x86: 15MB 한계
        // bool result = GC.TryStartNoGCRegion(15L * 1024 * 1024);

        Console.WriteLine($"# of GC: 0 == {GC.CollectionCount(0)}, 1 == {GC.CollectionCount(1)}, 2 == {GC.CollectionCount(2)}");
        bool result = GC.TryStartNoGCRegion(15L * 1024 * 1024 * 1024);
        Console.WriteLine($"# of GC: 0 == {GC.CollectionCount(0)}, 1 == {GC.CollectionCount(1)}, 2 == {GC.CollectionCount(2)}");
        Console.WriteLine($"TryStartNoGCRegion: {result}");

        {
            Console.WriteLine("Press any key to continue...");
            Console.ReadLine();
        }

        {
            long total = 7L * 1024 * 1024 * 1024;

            while (total > 0)
            {
                s_buf.Add(new byte[1024]);
                total -= 1024;
            }
        }

        Console.WriteLine($"# of GC: 0 == {GC.CollectionCount(0)}, 1 == {GC.CollectionCount(1)}, 2 == {GC.CollectionCount(2)}");
        GC.EndNoGCRegion();
        Console.WriteLine("End-of-program");
    }
}
